This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 873286 - race condition : master pty used in mom_reader()/mom_writer() alternates blocking and non blocking state
race condition : master pty used in mom_reader()/mom_writer() alternates bloc...
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: torque (Show other bugs)
16
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Haïkel Guémar
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-11-05 08:50 EST by Fabrice Bellet
Modified: 2013-02-13 10:32 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-02-13 10:32:22 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Fabrice Bellet 2012-11-05 08:50:58 EST
Hi!

I noticed that the file descriptor of the master pty shared by parent and child pbs_mom processes alternates between blocking and non blocking state. 

The consequence of this race condition is that read() from mom_writer() sometimes fails, and returns -1, with errno=EAGAIN (which is the expected behaviour when the related file descriptor is not blocking, but this is not expected by the code of mom_writer()), causing the submitted task to terminate unexpectedly.

The problem is caused because the corresponding mom_reader() function, from the other process calls write() on this same pty, this function is #defined to write_nonblocking_socket(), and this function temporally change the state of the pty from blocking to non_blocking.

I experience this problem systematically in a VM running Fedora 16 x86_64, when submitting interactive jobs. REproducing this case on real hardware (same distro, same packages) is much more difficult.

A possible fix would be to  gracefully handle the EAGAIN errno in the mom_writer() loop.
Comment 1 Fedora End Of Life 2013-01-16 09:28:45 EST
This message is a reminder that Fedora 16 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 16. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '16'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 16's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 16 is end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" and open it against that version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Fedora End Of Life 2013-02-13 10:32:25 EST
Fedora 16 changed to end-of-life (EOL) status on 2013-02-12. Fedora 16 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.